"use strict";

exports.__esModule = true;
exports.default = _default;

function filterComments(list, path, type) {
  return list.filter(function (o) {
    return o.type.toLowerCase() !== type.toLowerCase();
  });
}

function _default(_ref) {
  var t = _ref.types;
  return {
    name: 'remove-comments',
    visitor: {
      Program: function Program(path, _temp) {
        var _ref2 = _temp === void 0 ? {} : _temp,
            _ref2$opts$type = _ref2.opts.type,
            type = _ref2$opts$type === void 0 ? 'all' : _ref2$opts$type;

        path.traverse({
          enter: function enter(path) {
            var leadingCommentsList = path.node.leadingComments || [];
            var trailingCommentsList = path.node.trailingComments || [];

            if (leadingCommentsList.length > 0 || trailingCommentsList.length > 0) {
              if (type === 'none') return;

              if (type === 'all') {
                t.removeComments(path.node);
              } else {
                // t.removeComments是清空全部注释，并不能区分去掉哪种注释
                // t.removeComments(path.node);
                path.node.leadingComments = filterComments(leadingCommentsList, path, type);
                path.node.trailingComments = filterComments(trailingCommentsList, path, type);
              }
            }
          }
        });
      }
    }
  };
}